"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __values = (this && this.__values) || function (o) {
    var m = typeof Symbol === "function" && o[Symbol.iterator], i = 0;
    if (m) return m.call(o);
    return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
};
Object.defineProperty(exports, "__esModule", { value: true });
var normalizer_1 = require("./normalizer");
var RemoveDuplicateBackRelation = /** @class */ (function (_super) {
    __extends(RemoveDuplicateBackRelation, _super);
    function RemoveDuplicateBackRelation() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    RemoveDuplicateBackRelation.prototype.normalizeField = function (field, parentType, parentModel) {
        var e_1, _a;
        if (typeof field.type !== 'string' &&
            field.relatedField !== null &&
            !field.comments.some(function (c) { return c.isError; })) {
            try {
                for (var _b = __values(parentType.fields), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var other = _c.value;
                    if (typeof other.type !== 'string' &&
                        other.relatedField !== null &&
                        !other.comments.some(function (c) { return c.isError; }) &&
                        field !== other &&
                        field.name === other.name) {
                        // We found a related field with a conflicting name
                        // Mark both as error'd.
                        other.comments.push({
                            isError: true,
                            text: "Could not auto-generate backwards relation field, field name would be ambiguous.",
                        });
                        // TODO: Might want to intro multi-line comments.
                        other.comments.push({
                            isError: true,
                            text: "Please specify the name of this field and the name of the relation manually.",
                        });
                        other.comments.push({
                            isError: true,
                            text: "It references " + other.type.name + "." + other.relatedField.name + ".",
                        });
                        field.comments.push({
                            isError: true,
                            text: "Could not auto-generate backwards relation field, field name would be ambiguous.",
                        });
                        field.comments.push({
                            isError: true,
                            text: "Please specify the name of this field and the name of the relation manually.",
                        });
                        field.comments.push({
                            isError: true,
                            text: "It references " + field.type.name + "." + field.relatedField.name + ".",
                        });
                        // Do not mark a field as error'd multiple times.
                        break;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        }
    };
    return RemoveDuplicateBackRelation;
}(normalizer_1.Normalizer));
exports.RemoveDuplicateBackRelation = RemoveDuplicateBackRelation;
//# sourceMappingURL=removeDuplicateBackRelation.js.map